IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include \masm32\include\masm32rt.inc

    SetDelay PROTO :DWORD       ; real time load and delay

    atol   PROTO :DWORD
    atolsL PROTO :DWORD
    atol_2 PROTO :ptr BYTE

    correct equ <0>
    sdelay equ <1000>           ; loaded delay between tests

    iapadd MACRO                ; inter algo padding
      REPEAT 64
        int 3
      ENDM
    ENDM

  ; ---------------------------
  ; set processor core (1 to 4)
  ; ---------------------------
    Core MACRO corenum
      mov eax, 1
      .if eax == 1
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000000001b
      .elseif eax == 2
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000000010b
      .elseif eax == 3
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000000100b
      .elseif eax == 4
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000001000b
      .else
        xor ecx, ecx
      .endif
    ENDM
  ; ---------------------------

    .data
      align 4
      itm1 db "2147483647",0
      align 4
      itm2 db "-2147483648",0
      align 4
      itm3 db "0",0
      align 4
      itm4 db "123456",0
      align 4
      itm5 db "-123456",0

      align 16
      item1 dd itm1
      align 16
      item2 dd itm2
      align 16
      item3 dd itm3
      align 16
      item4 dd itm4
      align 16
      item5 dd itm5



    .code
    align 16

start:
   
; 

    Core 1              ; set the core to test algo

    call main
    inkey
    exit

; 

main proc

    IF correct
      print "-------------------",13,10
      print "Test correct result",13,10
      print "-------------------",13,10

      print item1," string",13,10
      print sstr$(rv(atol,item1))," result",13,10
      print item2," string",13,10
      print sstr$(rv(atol,item2))," result",13,10
      print item3," string",13,10
      print sstr$(rv(atol,item3))," result",13,10
      print item4," string",13,10
      print sstr$(rv(atol,item4))," result",13,10
      print item5," string",13,10
      print sstr$(rv(atol,item5))," result",13,10
    ENDIF

    push esi
    push edi

    print "-------------",13,10
    print "Timing result",13,10
    print "-------------",13,10

    mov edi, 4

  lpst:

  ; -----------------------------------

    invoke SetDelay, sdelay

    invoke GetTickCount
    push eax

    mov esi, 10000000

  @@:
    invoke atol,item1
    invoke atol,item2
    invoke atol,item3
    invoke atol,item4
    invoke atol,item5
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print sstr$(eax)," atol",13,10

  ; -----------------------------------

    invoke SetDelay, sdelay

    invoke GetTickCount
    push eax

    mov esi, 10000000

  @@:
    invoke atolsL,item1
    invoke atolsL,item2
    invoke atolsL,item3
    invoke atolsL,item4
    invoke atolsL,item5
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print sstr$(eax)," atolsL",13,10

  ; -----------------------------------

    invoke SetDelay, sdelay

    invoke GetTickCount
    push eax

    mov esi, 10000000

  @@:
    invoke atol_2,item1
    invoke atol_2,item2
    invoke atol_2,item3
    invoke atol_2,item4
    invoke atol_2,item5
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print sstr$(eax)," atol_2",13,10

  ; -----------------------------------

    sub edi, 1
    jnz lpst

    pop edi
    pop esi

    ret

main endp

; 

SetDelay proc msec:DWORD

  ; --------------------------------------
  ; This procedure loads the processor for
  ; the nominal time set in milliseconds
  ; --------------------------------------
    push ebx

    invoke SleepEx,1,0      ; yield to stabilise priority
    cpuid                   ; serialised instruction to clear cache/flags

    invoke GetTickCount     ; get a timing
    mov ebx, eax
    add ebx, msec           ; add required duration to it
    
  @@:                       ; spinlock loop load processor
    invoke GetTickCount
    cmp eax, ebx
    jle @B

    pop ebx
    cpuid                   ; flush instruction cache again
    ret

SetDelay endp

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

iapadd 

align 16

atol proc lpSrc:DWORD

    xor eax, eax
    mov edx, [esp+4]            ; lpSrc
    movzx ecx, BYTE PTR [edx]
    add edx, 1

    cmp ecx, "-"
    jne lbl0
    add eax, 1
    movzx ecx, BYTE PTR [edx]
    add edx, 1
  lbl0:
    mov [esp+4], eax            ; keep sign on stack
    xor eax, eax
    sub ecx, 48
    jc  lbl2

  lbl1:
  REPEAT 4
    lea eax, [eax+eax*4]        ; mul by 5
    lea eax, [ecx+eax*2]        ; then mul by 2
    movzx ecx, BYTE PTR [edx]
    add edx, 1
    sub ecx, 48
    jc  lbl2
  ENDM

    lea eax, [eax+eax*4]        ; mul by 5
    lea eax, [ecx+eax*2]        ; then mul by 2
    movzx ecx, BYTE PTR [edx]
    add edx, 1
    sub ecx, 48
    jnc  lbl1

  lbl2:
    mov ecx, [esp+4]            ; retrieve sign
    test ecx, ecx
    jz lbl3
    neg eax                     ; negative return value is sign set
  lbl3:

    ret 4

atol endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

iapadd

align 16
db 2 Dup(0)
atolsL proc String:DWORD
	pop			eax
	pop			edx
	xor			ecx, ecx
	push		eax
	cmp			byte ptr [edx], 2Dh
	mov			eax, ecx
	jne			@f    +3
    add			cl,  byte ptr [edx+1]
    jz				@f
	lea			eax, [eax+eax*4]
    lea			eax, [ecx+eax*2-30h]
	xor			ecx, ecx
    add			cl,  byte ptr [edx+2]
    jz				@f
	lea			eax, [eax+eax*4]
    lea			eax, [ecx+eax*2-30h]
	xor			ecx, ecx
	add			cl,  byte ptr [edx+3]
    jz				@f 
    lea			eax, [eax+eax*4]
    lea			eax, [ecx+eax*2-30h]
	xor			ecx, ecx
	add			cl,  byte ptr [edx+4]
    jz				@f
    lea			eax, [eax+eax*4]
    lea			eax, [ecx+eax*2-30h]
	xor			ecx, ecx
	add			cl,  byte ptr [edx+5]
	jz				@f
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+6]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+7]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+8]
     jz			@f 
	  lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+9]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+10]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
 @@:
	neg			eax
    ret
	add			cl,  byte ptr [edx]
    jz				@f
	lea			eax, [eax+eax*4]
    lea			eax, [ecx+eax*2-30h]
	xor			ecx, ecx
    add			cl,  byte ptr [edx+1]
    jz				@f
	lea			eax, [eax+eax*4]
    lea			eax, [ecx+eax*2-30h]
	xor			ecx, ecx
	add			cl,  byte ptr [edx+2]
    jz				@f 
    lea			eax, [eax+eax*4]
    lea			eax, [ecx+eax*2-30h]
	xor			ecx, ecx
	add			cl,  byte ptr [edx+3]
    jz				@f
    lea			eax, [eax+eax*4]
    lea			eax, [ecx+eax*2-30h]
	xor			ecx, ecx
	add			cl,  byte ptr [edx+4]
    jz				@f
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+5]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+6]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+7]
     jz			@f 
	  lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+8]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+9]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
 @@:
    ret
atolsL endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

atol_2 proc pszSrc: ptr BYTE

    mov edx,[esp+4] ;pszSrc
    movzx ecx,BYTE ptr [edx]
    test ecx,ecx
    jz @err
    cmp ecx,'-'
    jz @2
    lea eax,[ecx-'0']
    cntr = 1
    REPEAT 9
    movzx ecx,BYTE ptr [edx+cntr]
    test ecx,ecx
  @@:
    jnz @F
    ret 4
  @@:
    lea eax,[eax*4+eax]
    lea eax,[eax*2+ecx-'0']
    cntr = cntr + 1
    ENDM
    ret 4

    align 16
  @2:
    movzx ecx,BYTE ptr [edx+1]
    test ecx,ecx
    jz @fin2
    lea eax,[ecx-'0']
    cntr = 2
    REPEAT 9
    movzx ecx,BYTE ptr [edx+cntr]
    test ecx,ecx
    jz @fin2
    lea eax,[eax*4+eax]
    lea eax,[eax*2+ecx-'0']
    cntr = cntr + 1
    ENDM
    ;align 16
  @fin2:
    neg eax
    ret 4

    align 16
  @err:
    ret 4

atol_2 endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

end start
